package esercitazione4.binarysearchtrees;

public class BinarySearchTreeVisit {

	private static void printTabs(Integer livello){
		for (int i = 0; i < livello; i++) {
			System.out.print("\t");
		}
	}
	
	public static void print(BinarySearchTree tree, Integer level, String label){
		
		printTabs(level);
		
		if (tree == null)
			System.out.println("-");
		else {
			System.out.println(label + tree.getValue() );
		
			print(tree.getLeftChild(), level + 1, "L:");
			print(tree.getRightChild(), level + 1, "R:");	
		}
	}
}
